Unit HP12Cedarch;

interface

uses
    DVcrt,
    DVWin,
    windows,
    sysUtils,
    classes,
    hp12CVariables;

procedure AbreArchivo;
procedure EscribeArchivo (s: string);
procedure CopiaArchivoGrava;
function InNomArchivo(tecla: String):String;

implementation

{------------------------Abre y Crea Archivo-----------------------------------}
procedure AbreArchivo;

begin
    nomeArq := ('ClculosFeitos.txt');
    assign (arqCalculadora, nomeArq);
    rewrite(arqCalculadora);
    {$i-} reset (arqCalculadora); {$i+}
    append(arqCalculadora);
    writeln(arqCalculadora,'CALCULOS FEITOS');
    close(arqCalculadora);
end;

{-------------------------Crea Copia-------------------------------------------}
procedure CopiaArchivoGrava;
var
     nombre, nombre1, contenido: string;

begin
    textBackground (BLUE);   textColor (WHITE);
    write('QUAL  O NOME DO ARQUIVO? ' );
    sintSom ('HPINARCHIVO');
    delay(300);
    textBackground (BLACK);   textColor (WHITE);
    nombre:=InNomArchivo(nombre1);
    nomeArq:= ('C:\winvox\treino\' + nombre + '.txt');
    assign (ArqSalidaCalcu, nomeArq);
    {$i-} reset (ArqCalculadora); {$i+}
    {$i-} reset (ArqSalidaCalcu); {$i+}
    if ioresult <> 0 then rewrite(ArqSalidaCalcu);
    while( NOT eof(arqCalculadora) ) do begin
        readln(ArqCalculadora, contenido);
        append(ArqSalidaCalcu);
        writeln(ArqSalidaCalcu, contenido);
        close(ArqSalidaCalcu);
    end;
end;

{-------------------------Escribe Archivo--------------------------------------}
procedure EscribeArchivo(s: string);

begin
    if (s = 'x') then s:= '1/x';     //Inverso
    if (s = 'X') then s:= 'Sqrt';    //Raiz Cuadrada
    if (s = #24) then s:= 'LN';      //LN
    if (s = 'e') then s:= 'E';       //Exponente
    if (s = 'E') then s:= 'e^x';     //exponencial
    if (s = #5 ) then s:= 'y^x';     //Potencia
    if (s = 'f') then s:= 'n!';      //Fatorial
    if (s = 'g') then s:= 'INTG';    //Parte Entera
    if (s = 'G') then s:= 'FRAC';    //Parte Fraccionaria
    if (s = 'y') then s:= 'D%';      //Diferencia de Porcentaje
    if (s = 'Y') then s:= '%T';      //Porcentaje Total
    if (s = 't') then s:= 'CHS';     //Cambio de Signo
    if (s = 'D') then s:= 'D.MY';    //D.MY
    if (s = #4 ) then s:= 'M.DY';    //M.DY
    if (s = 'h') then s:= 'DDYS';    //D.MY
    if (s = 'H') then s:= 'DATE';    //M.DY
    if (s = 'n') then s:= 'n';       //n
    if (s = 'N') then s:= 'CALCULO n'; //Calculo n
    if (s = #14) then s:= '12x';     //12x
    if (s = 'i') then s:= 'i';       //i
    if (s = 'I') then s:= 'CALCULO i'; //Calculo i
    if (s = #9 ) then s:= '12/';     //12/
    if (s = 'p') then s:= 'PV';      //PV
    if (s = 'P') then s:= 'CALCULO PV'; //Calculo PV
    if (s = 'm') then s:= 'PMT';     //PMT
    if (s = 'M') then s:= 'CALCULO PMT'; //Calculo PMT
    if (s = 'v') then s:= 'FV';      //FV
    if (s = 'V') then s:= 'CALCULO FV'; //Calculo FV
    if (s = 'j') then s:= 'INT';     //Calculo Interes
    if (s = 'J') then s:= 'AMORT';   //AMORT
    if (s = 'r') then s:= 'RCL';     //Recupera Datos
    if (s = 'R') then s:= 'LSTx';    //Recupera Datos
    if (s = 's') then s:= 'STO';     //Armazena Datos
    if (s = 'a') then s:= 'CLEAR REG';     //Limpia Reg
    if (s = 'A') then s:= 'CLEAR ESTATISTICOS';     //Limpia Reg
    if (s = #1 ) then s:= 'CLEAR FINANCEIROS';     //Limpia Reg
    if (s = 'z') then s:= 'Z+';       //Z+
    if (s = 'Z') then s:= 'Z-';       //Z-
    if (s = #26) then s:= 'Z-';       //Z-
    if (s = 'q') then s:= 'Media';    //Media
    if (s = 'Q') then s:= 'Xw';       //Xw
    if (s = #17) then s:= 'S';        //S
    if (s = 'w') then s:= 'ELx';      //ELx
    if (s = 'W') then s:= 'ELy';      //ELy
    if (s = #23) then s:= 'r';        //r
    if (s = 'k') and (vecesCfo<=1) then s:= 'CFo';
    if (s = 'k') and (vecesCfo>1) then s:= 'CFj';
    if (s = 'K') then s:= 'NPV';      //NPV
    if (s = #11) then s:= 'Nj';       //Nj
    if (s = 'l') then s:= 'DB';       //DB
    if (s = 'L') then s:= 'SL';       //SL
    if (s = #12) then s:= 'SOYD';     //SOYD
    if (s = #10) and (memoriafi[6]=0) then s:= 'BEG';
    if (s = #10) and (memoriafi[6]=1) then s:= 'END';
    append (arqCalculadora);
    writeln(arqCalculadora,s);
    close (arqCalculadora);
end;

{---------------------------Nombre Archivo-------------------------------------}
function InNomArchivo(tecla: String):String;
var
    c, borrado: char;

begin
    repeat
        c:=readkey;
        if (c<> ENTER) then begin
            if (c = #0) then begin
                c:=readkey;
                sintSom ('HPTECLAINV');
            end else
            if (c = #$08) then begin
                if (length (tecla) > 0) then begin
                    borrado := tecla [length(tecla)];
                    sintSom ('HPBORRA');
                    sintCarac (borrado);
                    tecla := copy (tecla, 1, length(tecla)-1);
                    write (#8);
                end else begin
                    sintSom ('HPnada');
                end;
            end else
            if (c=#$1b) then begin
                delay(300);
                sintSom('HPRegresoCalc');
                NosaleESC:=TRUE;//inicializaSinSon;
                exit;
            end else
            if (c<= #30) or (c>= #127)then begin
                sintSom ('HPTECLAINV');
            end else begin
                tecla:=tecla+c;
                write(c);
                sintCarac(c);
                delay(100);
            end;
        end else  begin
            writeln;
        end;
     until c=ENTER;
     InNomArchivo:=tecla;
end;
{------------------------------------------------------------------------------}

end.
