unit HP12CfunRPN;

interface

uses
    windows,
    classes,
    dvWin,
    dvCrt,
    sysUtils,
    math,
    HP12Cedarch,
    HP12Creproduce,
    HP12Cvariables,
    HP12Cinicializa;

{------------------------------------------------------------------------------}
function esOperando(s:string):boolean;
function operarBasicas(v1,v2: real; op: string): real;
function operarPorcentaje(v1,v2: real; op: string): real;
function operarSimples(v1: double{real}; op: string): real;
function interes(var memoria: Tarray ; op: string): real;
function interesIrregular(var memoria: Tarray ; op: string): real;
function interesIrregularSimple(var memoria: Tarray ; op: string): real;
function depreciacion(var memoria: Tarray; op: string): real;
function FinanceirasNPVIRR(var vecesCFo: integer; v1: real; var memoria: Tarray; op: string): real;
function estadisticas(var veces: integer; v1: real; var memoria: Tarray; op: string): real;
function Calendario: real;
function Calendario30: real;
function CalculoFechas: real;
function NumeroDecimales:char;
{------------------------------------------------------------------------------}

implementation

{------------------------------------------------------------------------------}
function esOperando(s:string):boolean;
begin
  esOperando:= (s<>'+') AND (s<>'-') AND (s<>'*') AND (s<>'/') //basicas
            AND (s<>'%') AND (s<>'y') AND (s<>'Y')   //Porcentaje, Diferencia de Porcentaje, Porcentaje Total
            AND (s<>'x') AND (s<>'X') AND (s<>#24)   //Inverso, Raiz Cuadrada y Logaritmo Natural
            AND (s<>'e') AND (s<>'E') AND (s<>#5)    //Exponente, Exponencial y Elevado
            AND (s<>'f')      //Fatorial
            AND (s<>'g') AND (s<>'G')    //parte entera INTG y Fraccionaria FRAC
            AND (s<>'u') AND (s<>'U')    //Exemplos e Manuais
            AND (s<>'n') AND (s<>'N') AND (s<>#14)   //Nmero de periodos n
            AND (s<>'i') AND (s<>'I') AND (s<>#9)    //Tasa de interes
            AND (s<>'p') AND (s<>'P')   //Valor Presente PV
            AND (s<>'m') AND (s<>'M') AND (s<>#10)   //Pago periodico PMT, BEG, END
            AND (s<>'l') AND (s<>'L') AND (s<>#12)   //DB, SL, SOYD
            AND (s<>'v') AND (s<>'V')   //valor futuro FV
            AND (s<>'k') AND (s<>'K') AND (s<>#11)   //Fluxo de caixa inicial CFo, CFj,NPV,Nj
            AND (s<>'j') AND (s<>'J')    //Interes Simple y Amortizacion
            AND (s<>'z') AND (s<>'Z') AND (s<>#26)    //Sumatoria y Correcion de Sumatoria
            AND (s<>'D') AND (s<>#4)     //Configuracin Calendario
            AND (s<>'h') AND (s<>'H')    //Calculos Calendario
            AND (s<>'w') AND (s<>'W') AND (s<>#23)    //Estimacion lineal de X e Y, Coeficiente de correlacion
            AND (s<>'q') AND (s<>'Q') AND (s<>#17)     //Media, Media ponderada y desviacion Tipica
            AND (s<>'t')      //Cambio de Signo
            AND (s<>'r') AND (s<>'R') AND (s<>'s')     //recuperacin y almacenamiento de datos
            AND (s<>'a') AND (s<>'A') AND (s<>#1);   //Borrado de Registros
end;

{------------------------------------------------------------------------------}

function operarbasicas(v1,v2: real; op: string): real;
var producto, elevado: real;
begin
    if( op='+' ) then begin
        operarbasicas:=v1+v2;
    end;
    if( op='-' ) then begin
        operarbasicas:=v1-v2;
    end;
    if( op='*' ) then begin
        producto:=v1*v2;
        if producto>9.999999999e+99 then producto:= 9.999999999e+99;
        operarbasicas:=producto;
    end;
    if( op='/' ) then begin
        operarbasicas := v1/v2;
    end;
    if( op=#5) then begin
        elevado:=power(v1,v2);
        if elevado>9.999999999e+99 then elevado:= 9.999999999e+99;
        operarbasicas:=elevado;
    end;
    if LSTx=false then begin
        ValorLSTX:=v2;
        LSTx:=true;
    end;
end;

{----------------------------------------------------------------------------}

function operarPorcentaje(v1,v2: real; op: string): real;
begin
    //v1 llega lo que esta en la pila
    //v2 lo que se saco de la pila
    if( op='%' ) then begin
        operarPorcentaje:= (v1*v2)/100;
        exit;
    end;
    if( op='y' ) then begin
        operarPorcentaje:= 100*((v2-v1)/v1);
        exit;
    end;
    if( op='Y' ) then begin
        operarPorcentaje:= 100*(v2/v1);
        exit;
    end;
end;

{----------------------------------------------------------------------------}

function operarSimples(v1: double; op: string): real;
var
  fac, Exponencial: real;
begin
    fac:=1;
    //v1 lo que se saco de la pila
    if( op='x' ) then begin
        operarSimples:= (1/v1);
        exit;
    end;
    if( op='E' ) then begin
        exponencial:= EXP(v1);
        if exponencial>9.999999999e+99 then exponencial:= 9.999999999e+99;
        operarSimples:= exponencial;
        exit;
    end;
    if( op=#24 ) then begin
        operarSimples:= Ln(v1);
        exit;
    end;
    if( op='X' ) then begin
        operarSimples:= Sqrt(v1);
        exit;
    end;
    if( op='f' ) then begin
      while v1>=1 do begin
          fac:=fac*v1;
          v1:=v1-1;
          if fac>9.999999999e+99 then begin
            fac:= 9.999999999e+99;
            break;
          end;
      end;
    operarSimples:= fac;
    exit;
    end;
    if( op='g' ) then begin
        operarSimples:= Int(v1);
        exit;
    end;
    if( op='G' ) then begin
        operarSimples:= Frac(v1);
        exit;
    end;
end;

{------------------------------------------------------------------------------}

function interes(var memoria: Tarray; op: string): real;

var
  n,nresult,
  alfa, beta,
  i, iresult,
  PMT, PMTresult,
  FV, FVresult, s,
  PV, PVresult,
  INT1, INTresult,
  PRN1, PRNresult,
  A, B, C, fun, dfun: double;
  cuenta, j: integer;

  begin
    n:=memoria[1];
    i:=memoria[2];
    PV:=memoria[3];
    PMT:=memoria[4];
    FV:=memoria[5];
    s:=memoria[6];
    INTresult:=0;
    PRNresult:=0;

    if( op='j' ) then begin
        interes:=-1*(memoria[1]/360)*memoria[3]*(memoria[2]);
    end;
    if( op='J' ) then begin
        n:=v1;
        for j:=1 to 1000 do begin
            if j>n then break;
              INT1:= -(PV*i);
              PRN1:=PMT-INT1;
              PV:=PV+PRN1;
              INTresult:=INTresult+INT1;
              PRNresult:=PRNresult+PRN1;
        end;
        memoriafi[3]:= PV;
        memoriafi[7]:=INTresult;
        interes:=PRNresult;
    end;
    if( op='N' ) then begin
        nresult:=LN(((1+i*s)*PMT-FV*i)/((1+i*s)*PMT+PV*i))/LN(1+i);
        if (frac(nresult)<>0) then begin
            nresult:= INT(nresult)+1;
        end;
        interes:=nresult;
    end;
    if( op='I' ) then begin
        i:=0.01;
        for cuenta:=0  to 100 do begin
            alfa:= ((1+i*s)*(power(1+i,n)-1))/(i*power(1+i,n));
            beta:=1/power(1+i,n);
            A:=(1+i*s)*(1-Power(1+i,-n))/i;
            B:=(1+i*s)*(n*Power(1+i,-n-1))+s*(1-Power(1+i,-n));
            C:=n*FV*Power(1+i,-n-1);
            fun:= PV+(PMT*alfa)+(FV*beta);
            dfun:= (PMT/i)*(-A+B)-C;
            iresult:=i-(fun/dfun);
            i:=iresult;
        end;
        interes:=iresult*100;
    end;
    if( op='V' ) or ( op='P' ) or ( op='M' )then begin
        alfa:= ((1+i*s)*(power(1+i,n)-1))/(i*power(1+i,n));
        beta:=1/power(1+i,n);
        if( op='V' ) then begin
          FVresult:=-((PMT*alfa+PV)/beta);
          interes:=FVresult;
        end;
        if( op='P' ) then begin
          PVresult:=-(PMT*alfa+FV*beta);
          interes:=PVresult;
        end;
        if( op='M' ) then begin
          PMTresult:=-((PV+FV*beta)/alfa);
          interes:=PMTresult;
        end;
    end;
end;

{------------------------------------------------------------------------------}
function interesIrregular(var memoria: Tarray; op: string): real;

var
  n,
  alfaIrre, betaIrre, tetaIrre,
  i, iresult,
  PMT, PMTresult,
  FV, FVresult, s,
  PV, PVresult,
  A, B, C, D, fun, dfun: double;
  cuenta: integer;

  begin
    n:=memoria[1];
    i:=memoria[2];
    PMT:=memoria[4];
    FV:=memoria[5];
    s:=memoria[6];
    PV:=memoria[3];


    if( op='I' ) then begin
        i:=0.01;
        for cuenta:=0  to 100 do begin
            alfaIrre:=((1+i*s)*(power(1+i,INT(n))-1))/(i*power(1+i,INT(n)));
            betaIrre:=1/power(1+i,INT(n));
            tetaIrre:= power(1+i,FRAC(n));
            A:=(1+i*s)*(1-Power(1+i,-INT(n)))/i;
            B:=(1+i*s)*(n*Power(1+i,-INT(n)-1))+s*(1-Power(1+i,-INT(n)));
            C:=n*FV*Power(1+i,-INT(n)-1);
            D:=n*PV*power(1+i,FRAC(n)-1);
            fun:= (PV*tetaIrre)+(PMT*alfaIrre)+(FV*betaIrre);
            dfun:= D+(PMT/i)*(-A+B)-C;
            iresult:=i-(fun/dfun);
            {error:=(iresult-i)/iresult;
              if abs(error) < 0.00001 then begin
                write(iresult*100);
                exit;
            end;        }
            i:=iresult;
        end;
        interesIrregular:=iresult*100;
    end;
    if( op='V' ) or ( op='P' ) or ( op='M' )then begin
        alfaIrre:=((1+i*s)*(power(1+i,INT(n))-1))/(i*power(1+i,INT(n)));
        betaIrre:=1/power(1+i,INT(n));
        tetaIrre:= power(1+i,FRAC(n));
        if( op='V' ) then begin
          FVresult:=-((PMT*alfaIrre+PV*tetaIrre)/betaIrre);
          interesIrregular:=FVresult;
        end;
        if( op='P' ) then begin
          PVresult:=-(PMT*alfaIrre+FV*betaIrre)/tetaIrre;
          interesIrregular:=PVresult;
        end;
        if( op='M' ) then begin
          PMTresult:=-((PV*tetaIrre+FV*betaIrre)/alfaIrre);
          interesIrregular:=PMTresult;
        end;
    end;
end;

{------------------------------------------------------------------------------}
function interesIrregularSimple(var memoria: Tarray; op: string): real;

var
  n,
  alfaIrre, betaIrre, tetaIrre,
  i, iresult,
  PMT, PMTresult,
  FV, FVresult, s,
  PV, PVresult,
  A, B, C, D, fun, dfun: double;
  cuenta: integer;

  begin
    n:=memoria[1];
    i:=memoria[2];
    PMT:=memoria[4];
    FV:=memoria[5];
    s:=memoria[6];
    PV:=memoria[3];


    if( op='I' ) then begin
        i:=0.01;
        for cuenta:=0  to 100 do begin
            alfaIrre:=((1+i*s)*(power(1+i,INT(n))-1))/(i*power(1+i,INT(n)));
            betaIrre:=1/power(1+i,INT(n));
            tetaIrre:= (1+i*FRAC(n));
            A:=(1+i*s)*(1-Power(1+i,-INT(n)))/i;
            B:=(1+i*s)*(n*Power(1+i,-INT(n)-1))+s*(1-Power(1+i,-INT(n)));
            C:=n*FV*Power(1+i,-INT(n)-1);
            D:=PV*(1+i);
            fun:= (PV*tetaIrre)+(PMT*alfaIrre)+(FV*betaIrre);
            dfun:= D+(PMT/i)*(-A+B)-C;
            iresult:=i-(fun/dfun);
            {error:=(iresult-i)/iresult;
              if abs(error) < 0.00001 then begin
                write(iresult*100);
                exit;
            end;        }
            i:=iresult;
        end;
        interesIrregularSimple:=iresult*100;
    end;
    if( op='V' ) or ( op='P' ) or ( op='M' )then begin
        alfaIrre:=((1+i*s)*(power(1+i,INT(n))-1))/(i*power(1+i,INT(n)));
        betaIrre:=1/power(1+i,INT(n));
        tetaIrre:= (1+i*FRAC(n));
        if( op='V' ) then begin
          FVresult:=-((PMT*alfaIrre+PV*tetaIrre)/betaIrre);
          interesIrregularSimple:=FVresult;
        end;
        if( op='P' ) then begin
          PVresult:=-(PMT*alfaIrre+FV*betaIrre)/tetaIrre;
          interesIrregularSimple:=PVresult;
        end;
        if( op='M' ) then begin
          PMTresult:=-((PV*tetaIrre+FV*betaIrre)/alfaIrre);
          interesIrregularSimple:=PMTresult;
        end;
    end;
end;

{------------------------------------------------------------------------------}
function depreciacion(var memoria: Tarray; op: string): real;

var
  n, i, PMT, FV, s, PV,
  DPNj, RDV, RBV, SOYD: double;
  cuenta: integer;

begin
    n:=memoria[1];   //L
    i:=memoria[2];   //FACT
    PV:=memoria[3];  //SBV
    PMT:=memoria[4];
    FV:=memoria[5];  //SAL
    s:=memoria[6];
    DPNj:=memoria[10];
    RDV:=memoria[11];
    RBV:=memoria[12];
    cuenta:=1;

    if( op='l') then begin
        RDV:=PV-FV;
        RBV:=PV;
        while cuenta<=v1 do begin
            if cuenta=1 then begin
                DPNj:=PV*((i*100)/(100*n))*((cuenta*12)/12);
                depreciacion:=DPNj;
                RDV:=RDV-DPNj;
                RBV:=RBV-DPNj;
            end;
            if cuenta>1 then begin
                DPNj:=RBV*((i*100)/(100*n));
                depreciacion:=DPNj;
                //memoriafi[12]:=RBV-DPNj;
                RDV:=RDV-DPNj;
                RBV:=RBV-DPNj;
            end;
        cuenta:=cuenta+1;
        end;
    memoriafi[11]:=RDV;
    end;

    if( op='L') then begin
        RDV:=PV-FV;
        while cuenta<=v1 do begin
            if cuenta=1 then begin
                DPNj:=((PV-FV)/n)*((cuenta*12)/12);
                depreciacion:=DPNj;
                RDV:=RDV-DPNj;
            end;
            if v1>1 then begin
                DPNj:=((PV-FV)/n);
                depreciacion:=DPNj;
            RDV:=RDV-DPNj;
            end;
        cuenta:=cuenta+1;
        end;
    memoriafi[11]:=RDV;
    end;

    if( op=#12) then begin
      RDV:=PV-FV;
    while cuenta<=v1 do begin
        if cuenta=1 then begin
            SOYD:=((INT(n)+1)*(INT(n)+(2*FRAC(n))))/2;
            DPNj:=((n-cuenta+1)/SOYD)*(PV-FV);
            depreciacion:=DPNj;
            RDV:=RDV-DPNj;
        end;
        if cuenta>1 then begin
            SOYD:=((INT(n)+1)*(INT(n)+(2*FRAC(n))))/2;
            DPNj:=((n-cuenta+1)/SOYD)*(PV-FV);
            depreciacion:=DPNj;
            RDV:=RDV-DPNj;
        end;
    cuenta:=cuenta+1;
    end;
    memoriafi[11]:=RDV;
    end;
end;

{------------------------------------------------------------------------------}
function FinanceirasNPVIRR(var vecesCFo: integer; v1: real; var memoria: Tarray; op: string): real;
var
    NPV, a, b, r: real;
    i: integer;
begin
    NPV:=0;
    if( op='K' ) then begin              // Estimacion lineal de X
      for i:= 1 to vecesCFo do begin
        NPV:=NPV + memoria[i]/power(1 + memoriafi[2], i-1);
      end;
      FinanceirasNPVIRR:=NPV;
    end;

end;


{------------------------------------------------------------------------------}
function estadisticas(var veces: integer; v1: real; var memoria: Tarray; op: string): real;
var
    a, b, r: real;


begin
        b:=(memoria[6]-(memoria[2]*memoria[4])/veces)/(memoria[3]-(Sqr(memoria[2])/veces));
        a:=(memoria[4]/veces)-b*(memoria[2]/veces);
        r:=(memoria[6]-(memoria[2]*memoria[4]/veces))/Sqrt((memoria[3]-(Sqr(memoria[2])/veces))*(memoria[5]-(Sqr(memoria[4])/veces)));
    if( op='w' ) then begin              // Estimacion lineal de X
        estadisticas:= (v1-a)/b;
    end;
    if( op='W' ) then begin              // Estimacion lineal de Y
        estadisticas:= a+(b*v1);
        v1:=r;
    end;
    if( op=#23 ) then begin              // Coeficiente de Correlacion
        v1:=r;
        estadisticas:= r;
    end;
end;

{------------------------------------------------------------------------------}
function Calendario: real;
var
    DifDias, DT1, DT2, Xcalen1, Zcalen1, Xcalen2, Zcalen2: real;
begin

    if fecha1.mes <= 2 then begin
        Xcalen1:=0;
        Zcalen1:=fecha1.anio-1;
    end else begin
        Xcalen1:=INT(0.4*fecha1.mes + 2.3);
        Zcalen1:=fecha1.anio;
    end;
    if fecha2.mes <= 2 then begin
        Xcalen2:=0;
        Zcalen2:=fecha2.anio-1;
    end else begin
        Xcalen2:=INT(0.4*fecha2.mes + 2.3);
        Zcalen2:=fecha2.anio;
    end;
        DT1:= 365*fecha1.anio + 31*(fecha1.mes-1) + fecha1.dia + INT(Zcalen1/4) - Xcalen1;
        DT2:= 365*fecha2.anio + 31*(fecha2.mes-1) + fecha2.dia + INT(Zcalen2/4) - Xcalen2;
        DifDias:= DT2 - DT1;
        Calendario:= DifDias;

end;

{------------------------------------------------------------------------------}
function Calendario30: real;
var
    DifDias, DT1, DT2,
    Zcalen1, Zcalen2,
    RestoAnios, RestoMes: real;
begin

    if fecha1.dia = 31 then begin
        Zcalen1:=30;
    end else begin
        Zcalen1:=fecha1.dia;
    end;

    if fecha2.dia = 31 then begin
        if (fecha1.dia=30) or (fecha1.dia=31) then Zcalen2:=30;
        if fecha1.dia<30 then Zcalen2:=fecha2.dia;
    end else begin
        Zcalen2:=fecha2.dia;
    end;
        DT1:= 365*fecha1.anio + 30*fecha1.mes + Zcalen1;
        DT2:= 365*fecha2.anio + 30*fecha2.mes + Zcalen2;
        DifDias:= DT2 - DT1;
        Calendario30:= DifDias;

end;

{------------------------------------------------------------------------------}
function CalculoFechas: real;
var
    DifDias: real;
    cuentadias, mesexa, Febrero: integer;
    dia, mes, casomes: string;
    esbisiesto1, esbisiesto2: boolean;


begin
    cuentadias:=1;
    Esbisiesto1:=false;
    Esbisiesto2:=false;
    casomes:=FloatToSTR(fecha1.mes);
    mesexa:=STRtoINT(casomes);
    fechaR:=fecha1;



    if Frac(fecha1.anio/4) = 0  then esbisiesto1:=true;
    if (Frac(fecha1.anio/100)=0) and (Frac(fecha1.anio/400) <> 0) then esbisiesto1:=false;

    if esbisiesto1=true then begin
        febrero:=29;
    end else begin
        febrero:=28;
    end;


    case mesexa of
       1: difDias:=fecha1.dia+v1;
       2: difDias:=31+fecha1.dia+v1;
       3: difDias:=31+febrero+fecha1.dia+v1;
       4: difDias:=31+febrero+31+fecha1.dia+v1;
       5: difDias:=31+febrero+31+30+fecha1.dia+v1;
       6: difDias:=31+febrero+31+30+31+fecha1.dia+v1;
       7: difDias:=31+febrero+31+30+31+30+fecha1.dia+v1;
       8: difDias:=31+febrero+31+30+31+30+31+fecha1.dia+v1;
       9: difDias:=31+febrero+31+30+31+30+31+31+fecha1.dia+v1;
       10: difDias:=31+febrero+31+30+31+30+31+31+30+fecha1.dia+v1;
       11: difDias:=31+febrero+31+30+31+30+31+31+30+31+fecha1.dia+v1;
       12: difDias:=31+febrero+31+30+31+30+31+31+30+31+30+fecha1.dia+v1;
        else
    end;

    fecha2.anio:=fecha1.anio+INT(difdias/365);

    if difDias=0 then begin
        difdias:=365;
        fecha2.anio:=fecha1.anio-1;
    end;

    if difdias<0 then begin
      while difdias<0 do begin
          fecha2.anio:=fecha1.anio-1;
          fecha1.anio:=fecha1.anio-1;
          if Frac(fecha2.anio/4) = 0  then begin difDias:= difDias+366;
          end else difDias:= difDias+365;
      end;
    end;
    if difdias>0 then begin
      while difdias>365 do begin
          fecha2.anio:=fecha1.anio+1;
          fecha1.anio:=fecha1.anio+1;
          if Frac(fecha2.anio/4) = 0  then begin difDias:= difDias-366;
          end else difDias:= difDias-365;
      end;
    end;

    if Frac(fecha2.anio/4) = 0  then esbisiesto2:=true;
    if (Frac(fecha2.anio/100)=0) and (Frac(fecha2.anio/400) <> 0) then esbisiesto2:=false;


    if esbisiesto2=false then begin
        nomeArq:= ('C:\winvox\Som\Hp12cvox\Comandos\Datas\ARQCalendarioMeses.txt');
        assign (ArqCalendarioMeses,nomeArq);
        nomeArq:= ('C:\winvox\Som\Hp12cvox\Comandos\Datas\ArqCalendario.txt');
    end;
    if esbisiesto2=true then begin
        nomeArq:= ('C:\winvox\Som\Hp12cvox\Comandos\Datas\ARQCalendarioMesesBI.txt');
        assign (ArqCalendarioMeses,nomeArq);
        nomeArq:= ('C:\winvox\Som\Hp12cvox\Comandos\Datas\ArqCalendarioBI.txt');
    end;

    assign (ArqCalendario,nomeArq);
    {$i-} reset (ArqCalendario); {$i+}
    {$i-} reset (ArqCalendarioMeses); {$i+}
    repeat
    while ( NOT eof(arqCalendarioMeses) ) and (NOT eof(arqCalendariomeses)) do begin
        readln(ArqCalendarioMeses, mes);
        readln(ArqCalendario, dia);
        cuentadias:=cuentadias + 1;
        if cuentadias > difDias then begin
            val(mes,fecha2.mes,cod);
            val(dia,fecha2.dia,cod);
            break;
        end;
    end;
    {$i-} reset (ArqCalendario); {$i+}
    {$i-} reset (ArqCalendarioMeses); {$i+}
    until cuentadias>difDias;
    fecha1:=FechaR;

    if ValidaData1=true then begin
        writeln(' ! ',fecha2.dia:0:0,'.',fecha2.mes:0:0,'.',fecha2.anio:0:0,' ! ');
        CalculoFechas:=fecha2.dia;
    end;
    if ValidaData2=true then begin
        writeln(' ! ',fecha2.mes:0:0,'.',fecha2.dia:0:0,'.',fecha2.anio:0:0,' ! ');
        CalculoFechas:=fecha2.mes;
    end;

    fecha1:=FechaR;
end;

{------------------------------------------------------------------------------}
function NumeroDecimales:char;

var
   c: char;

begin
           repeat
            c:=readkey;
              case c of
                  #48: nDecimais:=0;
                  #49: nDecimais:=1;
                  #50: nDecimais:=2;
                  #51: nDecimais:=3;
                  #52: nDecimais:=4;
                  #53: nDecimais:=5;
                  #54: nDecimais:=6;
                  #55: nDecimais:=7;
                  #56: nDecimais:=8;
                  #57: nDecimais:=9;
                  #27: begin
                          FinHP12C;
                          exit;
                       end;
              else
                  sintSom ('HPdecimais');
              end;
           until c in [#48..#57];
           writeln(c);
           pilaReal (nDecimais);
           delay(300);
           sintSom ('HPCR');
           NumeroDecimales:=c;
end;

{------------------------------------------------------------------------------}

end.




