unit RPN;

interface

type
    PRPila = ^RPila;
    RPila = record
    valor: real;
    sig: PRPila;
end;

//---------------------------------------------------------
// funciones de manejo de pila
//---------------------------------------------------------

// pone un elemento en la pila
procedure poner(var p: PRPila; v: real);

// retorna true o false si hay elementos para
// sacar de la pila. Si hay elementos entonces
// el elemento que saca lo almacena en v
function sacar(var p: PRPila; var v:real):boolean;

//---------------------------------------------------------
// funciones de manejo de operadores
//---------------------------------------------------------

// retorna false si es es alguno de los siguientes caracteres: '+', '-', '*', '/'
function esOperando(s:string):boolean;

// retorna el resultado de la operacion entre
// los valores v1 y v2, siendo exp alguno de los
// operadores soportados por esta calculadora
function operar(v1,v2: real; op: string): real;

// muestra el contenido de la pila en orden inverso  40:
procedure mostrarPila(p:PRPila);
procedure falaNumeroReal (numero: double);


implementation

uses dvWin, dvCrt, sysUtils, dvlenum, HP12Cedarch;

// Comienza la implementacin del programa en general

function esOperando(s:string):boolean;     //recibe una cadena entrega un valor
begin                                      //logico
  esOperando:= (s<>'+')
            AND (s<>'-')
            AND (s<>'*')
            AND (s<>'/');
end;

{----------------------------------------------------------------------------}

function operar(v1,v2: real; op: string): real;
begin
    if( op='+' ) then begin
        operar:=v1+v2;
        exit;
    end;
    if( op='-' ) then begin
        operar:=v1-v2;
        exit;
    end;
    if( op='*' ) then begin
        operar:=v1*v2;
        exit;
    end;
    if( op='/' ) then begin
            if (v2 <> 0) then
            begin
                operar := v1/v2;
                exit;
            end else begin
                        write('Diviso por zero');
                        sintSom('HPXZERO');
                        writeln;
                        exit;
            end;
    end;
end;

{----------------------------------------------------------------------------}

procedure poner(var p: PRPila; v: real);
var
    nuevo:PRPila;
begin
  new(nuevo);
  nuevo^.valor:=v;
  nuevo^.sig:=p;
  p:=nuevo;
end;

{----------------------------------------------------------------------------}

function sacar(var p: PRPila; var v:real):boolean;
var
    aux:PRPila;
begin
    if( p=NIL ) then begin
        sacar:=false;
        exit;
    end;

    v:=p^.valor;
    aux:=p;
    p:=p^.sig;
    dispose(aux);
    sacar:=true;
end;

{----------------------------------------------------------------------------}

procedure mostrarPila(p:PRPila);
var
    aux,x,nuevo:PRPila;
    imprime: string;
begin
  aux:=NIL;

    // recorremos la pila (como lista) utilziando p
    // NOTEMOS que p se recibe por valor (sin var)
    // por lo tanto aunque aqui la modifiquemos no
    // quedara modificada en el programa principal
    // es decir: en el programa principal la variable
    // p no quedara en NIL
    while( p<>NIL ) do begin
        // por cada nodo de p creo un nuevo nodo
        // para la pila auxiliar
        new(nuevo);
        nuevo^.valor:=p^.valor;
        nuevo^.sig:=aux;
        aux:=nuevo;

        // avanzo p
        p:=p^.sig;
    end;

    // saco nodos de la pila auxiliar, los muestro
    // y los libero
    while( aux<>NIL ) do begin
        writeln(' = ',aux^.valor:0:2);
        imprime:=FloatToStr(aux^.valor);
        EscribeArquivo(imprime);
        x:=aux;
        aux:=aux^.sig;
        dispose(x);
    end;
end;

{--------------------------------------------------------}

procedure falaNumeroReal (numero: double);
var
    s: string;
    l: int64;
    i,nDecimais: integer;
    podeFalar: boolean;
begin
    sintSom ('HPIGUAL');
    nDecimais := 2;
    if numero < 0 then
        begin
            sintSom ('HPMENOS');
            numero := -numero;
        end;

    l := trunc (numero+0.000000000001);

    if l > 2000000000 then
        sintsoletra (intToStr (l))
    else
        falaNumeroConv (numeroParaString (l), MASCULINO);
    if numero - trunc (numero) <> 0 then
        begin
            str (numero:18:ndecimais, s);
            podeFalar := false;
            for i := 1 to length (s) do
                begin
                    if s[i] = '.' then
                        begin
                            sintSoletra ('.');  {virgula}
                            podeFalar := true;
                        end
                    else
                        if podeFalar then
                             falaNumeroConv (numeroParaString (ord(s[i]) and $f), MASCULINO);
                end;
        end;
end;

{--------------------------------------------------------}

end.




